diff -NaurdbB -xCVS -xconfigure$ -xconfig.h.in -xMakefile.in mrbayes-3.1.2.old/model.c mrbayes-3.1.2.new/model.c
--- mrbayes-3.1.2.old/model.c	Fri Dec 23 11:26:29 EST 2005
+++ mrbayes-3.1.2.new/model.c	Mon Aug 28 19:36:50 EDT 2006
@@ -364,7 +364,11 @@
 							MrBayesPrint ("%s                     Switching rates have independent uniform dist-\n", spacer);
 							MrBayesPrint ("%s                     ributions on the interval (%1.2lf,%1.2lf).\n", spacer, modelParams[i].covswitchUni[0], modelParams[i].covswitchUni[1]);
 							}
-						else if (!strcmp(modelParams[i].covSwitchPr,"Exponential"))
+						else if (!strcmp(modelParams[i].covSwitchPr,"PinvarUniform")) { /* - Allen */
+						  MrBayesPrint ("%s                     Switching rates have independent uniform distributions\n", spacer);
+						  MrBayesPrint ("%s                     on the interval (%1.2lf,%1.2lf) with a pinvar limit of %1.2lf.\n", spacer,
+								modelParams[i].covswitchUni[0], modelParams[i].covswitchUni[1],modelParams[i].covswitchMaxPinvar);
+						} else if (!strcmp(modelParams[i].covSwitchPr,"Exponential"))
 							{
 							MrBayesPrint ("%s                     Switching rates have independent exponential\n", spacer);
 							MrBayesPrint ("%s                     distributions with parameters (%1.2lf).\n", spacer, modelParams[i].covswitchExp);
@@ -574,7 +578,7 @@
 								if (!strcmp(modelParams[i].shapePr,"Uniform"))
 									{
 									MrBayesPrint ("%s                     Gamma shape parameter is uniformly dist-\n", spacer);
-									MrBayesPrint ("%s                     ributed on the interval (%1.2lf,%1.2lf).\n", spacer, modelParams[i].shapeUni[0], modelParams[i].shapeUni[1]);
+									MrBayesPrint ("%s                     ributed on the interval (%1.4lf,%1.2lf).\n", spacer, modelParams[i].shapeUni[0], modelParams[i].shapeUni[1]);
 									}
 								else if (!strcmp(modelParams[i].shapePr,"Exponential"))
 									{
@@ -583,7 +587,7 @@
 									}
 								else
 									{
-									MrBayesPrint ("%s                     Gamma shape parameter is fixed to %1.2lf.\n", spacer, modelParams[i].shapeFix);
+									MrBayesPrint ("%s                     Gamma shape parameter is fixed to %1.4lf.\n", spacer, modelParams[i].shapeFix);
 									}
 								}
 							if ((!strcmp(modelParams[i].ratesModel, "Propinv") || !strcmp(modelParams[i].ratesModel, "Invgamma")) && !strcmp(modelParams[i].covarionModel, "No"))
@@ -787,9 +791,9 @@
 					
 					if (j == P_TRATIO)
 						MrBayesPrint (" Parameter  = Tratio\n", spacer);
-					else if (j == P_REVMAT)
+					else if (j == P_REVMAT) {
 						MrBayesPrint (" Parameter  = Revmat\n", spacer);
-					else if (j == P_OMEGA)
+					} else if (j == P_OMEGA)
 						MrBayesPrint (" Parameter  = Omega\n", spacer);
 					else if (j == P_PI)
 						MrBayesPrint (" Parameter  = Statefreq\n", spacer);
@@ -834,8 +838,8 @@
 						else
 							MrBayesPrint ("%s            Prior      = Fixed(%1.2lf)\n", spacer, modelParams[i].tRatioFix);
 						}
-					else if (j == P_REVMAT)
-						{
+					else if (j == P_REVMAT) { /* Allen */
+						if (modelParams[i].dataType == DNA || modelParams[i].dataType == RNA) {
 						if (!strcmp(modelParams[i].revMatPr,"Dirichlet"))
 							MrBayesPrint ("%s            Prior      = Dirichlet(%1.2lf,%1.2lf,%1.2lf,%1.2lf,%1.2lf,%1.2lf)\n", spacer, 
 							modelParams[i].revMatDir[0], modelParams[i].revMatDir[1], modelParams[i].revMatDir[2],
@@ -844,8 +848,19 @@
 							MrBayesPrint ("%s            Prior      = Fixed(%1.2lf,%1.2lf,%1.2lf,%1.2lf,%1.2lf,%1.2lf)\n", spacer, 
 							modelParams[i].revMatFix[0], modelParams[i].revMatFix[1], modelParams[i].revMatFix[2],
 							modelParams[i].revMatFix[3], modelParams[i].revMatFix[4], modelParams[i].revMatFix[5]);
-						}
-					else if (j == P_OMEGA)
+						} else if (modelParams[i].dataType == PROTEIN) {
+							if ((!strcmp(modelParams[i].aaModelPr, "Fixed")) &&
+				    			    (!strcmp(modelParams[i].aaModel, "Gtr")) &&
+				    			    (!strcmp(modelParams[i].aaRevMatPr,"Dirichlet")))
+								MrBayesPrint ("%s            Prior      = Dirichlet(...)\n", spacer);
+							else if (!strcmp(modelParams[i].aaModelPr, "Mixed"))
+								MrBayesPrint ("%s            Prior      = Mixed (see below)\n", spacer);
+							else
+								MrBayesPrint ("%s            Prior      = Fixed(%s)\n",spacer,
+									     modelParams[i].aaModel);
+						} else
+							MrBayesPrint("%s            Prior      = %s\n",spacer,modelParams[i].revMatPr);  
+					} else if (j == P_OMEGA)
 						{
 						if (!strcmp(modelParams[i].omegaVar,"Equal"))
 							{
@@ -987,11 +1002,11 @@
 					else if (j == P_SHAPE)
 						{
 						if (!strcmp(modelParams[i].shapePr,"Uniform"))
-							MrBayesPrint ("%s            Prior      = Uniform(%1.2lf,%1.2lf)\n", spacer, modelParams[i].shapeUni[0], modelParams[i].shapeUni[1]);
+							MrBayesPrint ("%s            Prior      = Uniform(%1.4lf,%1.2lf)\n", spacer, modelParams[i].shapeUni[0], modelParams[i].shapeUni[1]);
 						else if (!strcmp(modelParams[i].shapePr,"Exponential"))
 							MrBayesPrint ("%s            Prior      = Exponential(%1.2lf)\n", spacer, modelParams[i].shapeExp);
 						else
-							MrBayesPrint ("%s            Prior      = Fixed(%1.2lf)\n", spacer, modelParams[i].shapeFix);
+							MrBayesPrint ("%s            Prior      = Fixed(%1.4lf)\n", spacer, modelParams[i].shapeFix);
 						}
 					else if (j == P_PINVAR)
 						{
@@ -1011,6 +1026,9 @@
 						{
 						if (!strcmp(modelParams[i].covSwitchPr,"Uniform"))
 							MrBayesPrint ("%s            Prior      = Uniform(%1.2lf,%1.2lf)\n", spacer, modelParams[i].covswitchUni[0], modelParams[i].covswitchUni[1]);
+						else if (!strcmp(modelParams[i].covSwitchPr,"PinvarUniform"))
+							MrBayesPrint ("%s            Prior      = PinvarUniform(%1.2lf,%1.2lf,%1.2lf)\n",
+								      spacer, modelParams[i].covswitchUni[0], modelParams[i].covswitchUni[1], modelParams[i].covswitchMaxPinvar);
 						else if (!strcmp(modelParams[i].covSwitchPr,"Exponential"))
 							MrBayesPrint ("%s            Prior      = Exponential(%1.2lf)\n", spacer, modelParams[i].covswitchExp);
 						else
@@ -3231,13 +3249,13 @@
 									}
 								if (modelParams[i].shapeUni[0] < MIN_SHAPE_PARAM)
 									{
-									MrBayesPrint ("%s   Lower value for uniform cannot be less than %1.2lf\n", spacer, MIN_SHAPE_PARAM);
+									MrBayesPrint ("%s   Lower value for uniform cannot be less than %1.4lf\n", spacer, MIN_SHAPE_PARAM);
 									return (ERROR);
 									}
 								if (nApplied == 0 && numCurrentDivisions == 1)
-									MrBayesPrint ("%s   Setting Shapepr to Uniform(%1.2lf,%1.2lf)\n", spacer, modelParams[i].shapeUni[0], modelParams[i].shapeUni[1]);
+									MrBayesPrint ("%s   Setting Shapepr to Uniform(%1.4lf,%1.2lf)\n", spacer, modelParams[i].shapeUni[0], modelParams[i].shapeUni[1]);
 								else
-									MrBayesPrint ("%s   Setting Shapepr to Uniform(%1.2lf,%1.2lf) for partition %d\n", spacer, modelParams[i].shapeUni[0], modelParams[i].shapeUni[1], i+1);
+									MrBayesPrint ("%s   Setting Shapepr to Uniform(%1.4lf,%1.2lf) for partition %d\n", spacer, modelParams[i].shapeUni[0], modelParams[i].shapeUni[1], i+1);
 								expecting  = Expecting(RIGHTPAR);
 								}
 							}
@@ -3262,13 +3280,13 @@
 								}
 							if (modelParams[i].shapeFix < MIN_SHAPE_PARAM)
 								{
-								MrBayesPrint ("%s   Shape parameter cannot be less than %1.2lf\n", spacer, MIN_SHAPE_PARAM);
+								MrBayesPrint ("%s   Shape parameter cannot be less than %1.4lf\n", spacer, MIN_SHAPE_PARAM);
 								return (ERROR);
 								}
 							if (nApplied == 0 && numCurrentDivisions == 1)
-								MrBayesPrint ("%s   Setting Shapepr to Fixed(%1.2lf)\n", spacer, modelParams[i].shapeFix);
+								MrBayesPrint ("%s   Setting Shapepr to Fixed(%1.4lf)\n", spacer, modelParams[i].shapeFix);
 							else
-								MrBayesPrint ("%s   Setting Shapepr to Fixed(%1.2lf) for partition %d\n", spacer, modelParams[i].shapeFix, i+1);
+								MrBayesPrint ("%s   Setting Shapepr to Fixed(%1.4lf) for partition %d\n", spacer, modelParams[i].shapeFix, i+1);
 							expecting  = Expecting(RIGHTPAR);
 							}
 						}
@@ -3296,8 +3314,8 @@
 					{
 					nApplied = NumActiveParts ();
 					for (i=0; i<numCurrentDivisions; i++)
-						{
-						if ((activeParts[i] == YES || nApplied == 0) && (modelParams[i].dataType == DNA || modelParams[i].dataType == RNA))
+						{ /* Had lacked PROTEIN as possible; not adding RESTRICTION or STANDARD since am not familiar with details of those - Allen */
+						if ((activeParts[i] == YES || nApplied == 0) && (modelParams[i].dataType == DNA || modelParams[i].dataType == RNA || modelParams[i].dataType == PROTEIN))
 							strcpy(modelParams[i].pInvarPr, tempStr);
 						}
 					}
@@ -3318,8 +3336,8 @@
 				{
 				nApplied = NumActiveParts ();
 				for (i=0; i<numCurrentDivisions; i++)
-					{
-					if ((activeParts[i] == YES || nApplied == 0) && (modelParams[i].dataType == DNA || modelParams[i].dataType == RNA))
+					{ /* Had lacked PROTEIN as possible; not adding RESTRICTION or STANDARD since am not familiar with details of those - Allen */
+					if ((activeParts[i] == YES || nApplied == 0) && (modelParams[i].dataType == DNA || modelParams[i].dataType == RNA || modelParams[i].dataType == PROTEIN))
 						{
 						if (!strcmp(modelParams[i].pInvarPr,"Uniform"))
 							{
@@ -3762,7 +3780,7 @@
 								{
 								if (modelParams[i].covswitchUni[0] >= modelParams[i].covswitchUni[1])
 									{
-									MrBayesPrint ("%s   Lower value for uniform should be greater than upper value\n", spacer);
+									MrBayesPrint ("%s   Lower value for uniform should be less than upper value\n", spacer);
 									return (ERROR);
 									}
 								if (nApplied == 0 && numCurrentDivisions == 1)
@@ -3772,7 +3790,40 @@
 								expecting  = Expecting(RIGHTPAR);
 								}
 							}
-						else if (!strcmp(modelParams[i].covSwitchPr,"Exponential"))
+						else if (!strcmp(modelParams[i].covSwitchPr,"PinvarUniform")) { /* - Allen */
+						  sscanf (tkn, "%lf", &tempD);
+						  if (numVars[i] > 1)
+						    modelParams[i].covswitchMaxPinvar = tempD;
+                                                  else
+						    modelParams[i].covswitchUni[numVars[i]] = tempD;
+                                                  numVars[i]++;
+						  if (numVars[i] < 3)
+						    expecting  = Expecting(COMMA);
+						  else {
+						    if (modelParams[i].covswitchUni[0] >= modelParams[i].covswitchUni[1]) {
+						      MrBayesPrint ("%s   Lower value for uniform should be less than upper value\n", spacer);
+						      return (ERROR);
+						    } else if (modelParams[i].covswitchMaxPinvar > 1) {
+						      MrBayesPrint ("%s   Covswitchpr max pinvar must be 1 or less\n", spacer);
+						      return (ERROR);
+						    } else if (modelParams[i].covswitchMaxPinvar <= 0) {
+						      MrBayesPrint ("%s   Covswitchpr max pinvar must be greater than 0\n", spacer);
+						      return (ERROR);
+						    } else if (modelParams[i].covswitchMaxPinvar <= (modelParams[i].covswitchUni[0]/(modelParams[i].covswitchUni[0]+modelParams[i].covswitchUni[1]))) {
+						      MrBayesPrint ("%s   Covswitchpr max pinvar must be above %1.4lf with uniform %1.2lf to %1.2lf\n",
+								    spacer, (modelParams[i].covswitchUni[0]/(modelParams[i].covswitchUni[0]+modelParams[i].covswitchUni[1])), modelParams[i].covswitchUni[0], modelParams[i].covswitchUni[1]);
+						      return (ERROR);
+						    } else if (modelParams[i].covswitchMaxPinvar == 1)
+						      MrBayesPrint ("%s   Covswitchpr max pinvar of 1 has no effect\n", spacer);
+						    if (nApplied == 0 && numCurrentDivisions == 1)
+						      MrBayesPrint ("%s   Setting Covswitchpr to PinvarUniform(%1.2lf,%1.2lf,%1.4lf)\n",
+								    spacer, modelParams[i].covswitchUni[0], modelParams[i].covswitchUni[1], modelParams[i].covswitchMaxPinvar);
+						    else
+						      MrBayesPrint ("%s   Setting Covswitchpr to PinvarUniform(%1.2lf,%1.2lf,%1.4lf) for partition %d\n", spacer,
+								    modelParams[i].covswitchUni[0], modelParams[i].covswitchUni[1], modelParams[i].covswitchMaxPinvar, i+1);
+						    expecting  = Expecting(RIGHTPAR);
+						  }
+						} else if (!strcmp(modelParams[i].covSwitchPr,"Exponential"))
 							{
 							sscanf (tkn, "%lf", &tempD);
 							modelParams[i].covswitchExp = tempD;
@@ -4100,7 +4151,10 @@
 										sum += tempStateFreqs[j];
 									if (AreDoublesEqual (sum, (MrBFlt) 1.0, (MrBFlt) 0.001) == NO)
 										{
-										MrBayesPrint ("%s   State frequencies do not sum to 1.0\n", spacer);
+										  if (nApplied == 0 && numCurrentDivisions == 1)
+										    MrBayesPrint ("%s   State frequencies do not sum to 1.0 (%f)\n", spacer, sum);
+										  else
+										    MrBayesPrint ("%s   State frequencies do not sum to 1.0 for partition %d (%f)\n", spacer, i+1, sum);
 										return (ERROR);
 										}
 									strcpy(modelParams[i].stateFreqsFixType, "User");
@@ -6138,9 +6192,9 @@
 			*isApplic2 = NO;
 
 		/* check that data type is the same for both partitions */
-		if (isFirstNucleotide == YES && isSecondNucleotide == NO)
+		if (isFirstNucleotide != isSecondNucleotide)
 			isSame = NO;
-		if (isFirstProtein == YES && isSecondProtein == NO)
+		if (isFirstProtein != isSecondProtein)
 			isSame = NO;
 
 		/* GTR applies to both part1 and part2. We now need to check if the prior is the same for both. */
@@ -6764,8 +6818,15 @@
 				isSame = NO;
 			if (AreDoublesEqual (modelParams[part1].covswitchUni[1], modelParams[part2].covswitchUni[1], (MrBFlt) 0.00001) == NO)
 				isSame = NO;
-			}
-		else if (!strcmp(modelParams[part1].covSwitchPr,"Exponential") && !strcmp(modelParams[part2].covSwitchPr,"Exponential"))
+		} else if (!strcmp(modelParams[part1].covSwitchPr,"PinvarUniform") && !strcmp(modelParams[part2].covSwitchPr,"PinvarUniform")) {
+		  /* We assume the person has not set covswitchMaxPinvar to 1, which makes PinvarUniform equivalent to Uniform - Allen */
+		  if (AreDoublesEqual (modelParams[part1].covswitchUni[0], modelParams[part2].covswitchUni[0], (MrBFlt) 0.00001) == NO)
+		    isSame = NO;
+		  else if (AreDoublesEqual (modelParams[part1].covswitchUni[1], modelParams[part2].covswitchUni[1], (MrBFlt) 0.00001) == NO)
+		    isSame = NO;
+		  else if (AreDoublesEqual (modelParams[part1].covswitchMaxPinvar, modelParams[part2].covswitchMaxPinvar, (MrBFlt) 0.00001) == NO)
+		    isSame = NO;
+		} else if (!strcmp(modelParams[part1].covSwitchPr,"Exponential") && !strcmp(modelParams[part2].covSwitchPr,"Exponential"))
 			{
 			if (AreDoublesEqual (modelParams[part1].covswitchExp, modelParams[part2].covswitchExp, (MrBFlt) 0.00001) == NO)
 				isSame = NO;
